package com.utopiaindustries.selftrucking.Activities.dashboardScreens;

import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.lifecycle.ViewModelProvider;

import com.utopiaindustries.selftrucking.Activities.dashboardScreens.viewModels.HomeViewModel;
import com.utopiaindustries.selftrucking.Activities.loginScreens.SplashActivity;
import com.utopiaindustries.selftrucking.R;
import com.utopiaindustries.selftrucking.helper.Helper;
import com.utopiaindustries.selftrucking.helper.Preference;
import com.utopiaindustries.selftrucking.models.ContainerWorkflow;
import com.utopiaindustries.selftrucking.models.DriverResponse;
import com.utopiaindustries.selftrucking.models.PickResponse;
import com.utopiaindustries.selftrucking.models.PickupRequest;
import com.utopiaindustries.selftrucking.models.PickupRequestForComplete;
import com.utopiaindustries.selftrucking.utils.ProgressDialogFragment;

import java.util.ArrayList;
import java.util.List;

public class ContainerDetailActivity extends AppCompatActivity {

    TextView container_no, container_origin, containerDestination, driverId, driverName, container_status;
    Button btnMarkPicked;
    //FoodDetailObj singleList;
    ContainerWorkflow containerWorkflow;
    String truckerId = "";
    String truckerName = "";
    HomeViewModel homeViewModel;
    String currentStatus = "PICKED";
    int currentPosition = 0;
    DriverResponse driverResponse;
    List<ContainerWorkflow> containerList = new ArrayList<>();
    ImageView img_back;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_container_detail);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        if( !Helper.isNetworkConnected(this) ){
            Toast.makeText( this, "No Internet Connection", Toast.LENGTH_LONG ).show();
        }

        initializeLayout();

        img_back.setOnClickListener(v -> finish());

        btnMarkPicked.setOnClickListener(v -> {

            /*if (currentStatus.equalsIgnoreCase("DROPPED")) {
                PickupRequestForComplete request = new PickupRequestForComplete(containerWorkflow.getOriginId(),
                        containerWorkflow.getDestinationId(),
                        containerWorkflow.getContainerNo(),
                        currentStatus,
                        50,
                        "USD",
                        Integer.parseInt(truckerId),
                        containerWorkflow.getTruckLoadId() != null ? containerWorkflow.getTruckLoadId() : 0);

                Log.e("Pick-Request: ", ""+ request.toString());
                homeViewModel.pickTruckLoad(request);
            }
            else {
                PickupRequest request = new PickupRequest(containerWorkflow.getOriginId(),
                        containerWorkflow.getDestinationId(),
                        containerWorkflow.getContainerNo(),
                        currentStatus,
                        50,
                        "USD",
                        Integer.parseInt(truckerId));
            }*/

            /*if (currentStatus.equalsIgnoreCase("DROPPED")) {
                Log.e("Pick-Request: ", "DROPPED "+currentStatus);
            }
            else {
                Log.e("Pick-Request: ", "ELSE "+currentStatus);
            }*/

            PickupRequest request = new PickupRequest(containerWorkflow.getOriginId(),
                    containerWorkflow.getDestinationId(),
                    containerWorkflow.getContainerNo(),
                    currentStatus,
                    50,
                    "USD",
                    Integer.parseInt(truckerId),
                    containerWorkflow.getTruckLoadId() != null ? containerWorkflow.getTruckLoadId() : 0);

           // Log.e("Pick-Request: ", ""+ request.toString());
            homeViewModel.pickTruckLoad(request);

            //Toast.makeText(this, "Container marked as picked", Toast.LENGTH_SHORT).show();

            //Intent intent = new Intent(ContainerDetailActivity.this, TrackingActivity.class);
            //intent.putExtra("container_id", container.getContainerId());
            //startActivity(intent);

        });
    }

    public void initializeLayout() {
        container_no = findViewById(R.id.container_no);
        container_origin = findViewById(R.id.container_origin);
        containerDestination = findViewById(R.id.container_destination);
        container_status = findViewById(R.id.container_status);
        driverId = findViewById(R.id.driver_Id);
        driverName = findViewById(R.id.driver_name);
        btnMarkPicked = findViewById(R.id.btn_mark_picked);
        img_back = findViewById(R.id.img_back);
        homeViewModel = new ViewModelProvider(this).get(HomeViewModel.class);

        containerWorkflow = (ContainerWorkflow) getIntent().getSerializableExtra("SingleContainerInfo");

        truckerId = getIntent().getStringExtra("TruckerId");
        truckerName = getIntent().getStringExtra("TruckerName");
        currentPosition = getIntent().getIntExtra("position",0);
      //  Log.e("currentPosition: ",""+currentPosition);

        driverResponse = Helper.getPreferenceObjectJson(this, "DriverResponse");
        //assert driverResponse != null;
        //containerList.addAll(driverResponse.getContainerWorkflowData());

        homeViewModel.getLoadingState().observe(this, isLoading -> {
            if (isLoading != null && isLoading) {
                showProgressDialog();
            } else {
                dismissProgressDialog();
            }
        });

        homeViewModel.getErrorMessage().observe(this, errorResponse -> {
            if (errorResponse.isEmpty()) {
                Toast.makeText(this, "Something went wrong", Toast.LENGTH_SHORT).show();
            }
            else {
                Toast.makeText(this, errorResponse, Toast.LENGTH_SHORT).show();
            }
        });

        homeViewModel.getPickLiveData().observe(this, pickResponse -> {
            if (pickResponse != null) {
                //Log.d("API", "Message: " + pickResponse.getMessage());
                //Log.d("API", "Status: " + pickResponse.getStatus());

                Toast.makeText(this, pickResponse.getMessage(), Toast.LENGTH_SHORT).show();
                ContainerWorkflow containerToUpdate = getContainerByNo(driverResponse.getContainerWorkflowData(), containerWorkflow.getContainerNo());

                // Modify the values

                containerToUpdate.setCurrentStatus(pickResponse.getTruckLoad().getStatus());
                containerToUpdate.setTruckLoadId(pickResponse.getTruckLoad().getTruckLoadId());

                Helper.setPreferenceObject(getApplicationContext(), driverResponse, "DriverResponse");

                DriverResponse driverResponse1 = Helper.getPreferenceObjectJson(getApplicationContext(), "DriverResponse");
                ContainerWorkflow containerToUpdate1 = driverResponse1.getContainerWorkflowData().get(currentPosition);
                containerWorkflow = getContainerByNo(driverResponse1.getContainerWorkflowData(), containerWorkflow.getContainerNo());//driverResponse1.getContainerWorkflowData().get(currentPosition);
                //Log.e("driverResponse1: ",""+driverResponse1.getContainerWorkflowData());

                /*Log.e("After Update: ","****************************************");
                Log.e("containerToUpdate1-ContainerNo: ",""+containerWorkflow.getContainerNo());
                Log.e("containerToUpdate1-OriginId: ",""+containerWorkflow.getOriginId());
                Log.e("containerToUpdate1-origin: ",""+containerWorkflow.getOrigin());
                Log.e("containerToUpdate1-destination: ",""+containerWorkflow.getDestination());
                Log.e("containerToUpdate1-destinationId: ",""+containerWorkflow.getDestinationId());
                Log.e("containerToUpdate1-Status: ",""+containerWorkflow.getCurrentStatus());
                Log.e("containerToUpdate1-truckLoadId: ",""+containerWorkflow.getTruckLoadId());*/

                setContainerDetail(containerWorkflow);

                //Toast.makeText(ContainerDetailActivity.this,pickResponse.getMessage(), Toast.LENGTH_SHORT).show();

                /*if (driverResponse != null && driverResponse.getContainerWorkflowData() != null
                        && currentPosition < driverResponse.getContainerWorkflowData().size()) {
                    ContainerWorkflow containerToUpdate = driverResponse.getContainerWorkflowData().get(currentPosition);

                    // Modify the values

                    containerToUpdate.setCurrentStatus(pickResponse.getTruckLoad().getStatus());
                    containerToUpdate.setTruckLoadId(pickResponse.getTruckLoad().getTruckLoadId());

                    Helper.setPreferenceObject(getApplicationContext(), driverResponse, "DriverResponse");

                    DriverResponse driverResponse1 = Helper.getPreferenceObjectJson(getApplicationContext(), "DriverResponse");
                    ContainerWorkflow containerToUpdate1 = driverResponse1.getContainerWorkflowData().get(currentPosition);
                    containerWorkflow = driverResponse1.getContainerWorkflowData().get(currentPosition);

                    Log.e("After Update: ","****************************************");
                    Log.e("containerToUpdate1-ContainerNo: ",""+containerWorkflow.getContainerNo());
                    Log.e("containerToUpdate1-OriginId: ",""+containerWorkflow.getOriginId());
                    Log.e("containerToUpdate1-origin: ",""+containerWorkflow.getOrigin());
                    Log.e("containerToUpdate1-destination: ",""+containerWorkflow.getDestination());
                    Log.e("containerToUpdate1-destinationId: ",""+containerWorkflow.getDestinationId());
                    Log.e("containerToUpdate1-Status: ",""+containerWorkflow.getCurrentStatus());
                    Log.e("containerToUpdate1-truckLoadId: ",""+containerWorkflow.getTruckLoadId());

                    setContainerDetail(containerWorkflow);
                }*/
            }
        });

        setContainerDetail(containerWorkflow);
    }

    public ContainerWorkflow getContainerByNo(List<ContainerWorkflow> containerList, String containerNo) {
        for (ContainerWorkflow container : containerList) {
            if (container.getContainerNo().equals(containerNo)) {
                return container;
            }
        }
        return null;
    }

    private void setContainerDetail(ContainerWorkflow containerWorkflow) {

        container_no.setText(Html.fromHtml("<b>Container No:</b> " + containerWorkflow.getContainerNo(), Html.FROM_HTML_MODE_LEGACY));
        container_origin.setText(Html.fromHtml("<b>Terminal Info:</b> " + containerWorkflow.getOrigin(), Html.FROM_HTML_MODE_LEGACY));
        containerDestination.setText(Html.fromHtml("<b>Destination:</b> " + containerWorkflow.getDestination(), Html.FROM_HTML_MODE_LEGACY));
        driverId.setText(Html.fromHtml("<b>Driver Id:</b> " + truckerId, Html.FROM_HTML_MODE_LEGACY));
        driverName.setText(Html.fromHtml("<b>Driver Name:</b> " + truckerName, Html.FROM_HTML_MODE_LEGACY));
        currentStatus = containerWorkflow.getCurrentStatus();

        if (containerWorkflow.getCurrentStatus() != null && !containerWorkflow.getCurrentStatus().equalsIgnoreCase("")) {
            container_status.setText(Html.fromHtml("<b>Status:</b> " + containerWorkflow.getCurrentStatus(), Html.FROM_HTML_MODE_LEGACY));
        }
        else {
            container_status.setText(Html.fromHtml("<b>Status:</b> " + "Assigned", Html.FROM_HTML_MODE_LEGACY));
        }

        if (containerWorkflow.getCurrentStatus() != null) {
           // Log.e("Status: ",""+(containerWorkflow.getCurrentStatus().toLowerCase()));
            switch (containerWorkflow.getCurrentStatus()) {


                case "PICKED":
                    Preference.setMyIntPref(Helper.project_file, "CurrentPosition",this,2);
                    btnMarkPicked.setBackgroundColor(ContextCompat.getColor(this, R.color.picked_color));
                    btnMarkPicked.setText("Mark it Dropped");
                    currentStatus = "DROPPED";
                    break;

                case "DROPPED":
                    Preference.setMyIntPref(Helper.project_file, "CurrentPosition",this,3);
                    btnMarkPicked.setBackgroundColor(ContextCompat.getColor(this, R.color.dropped_color));
                    btnMarkPicked.setText("Mark it Completed");
                    currentStatus = "COMPLETED";
                    break;

                case "COMPLETED":
                    //btnMarkPicked.setBackgroundColor(ContextCompat.getColor(this, R.color.completed_color));
                    Preference.setMyIntPref(Helper.project_file, "CurrentPosition",this,0);
                    btnMarkPicked.setText("Mark it Picked");
                    currentStatus = "PICKED";

                    Intent myIntent = new Intent(ContainerDetailActivity.this, HomeActivity.class);
                    myIntent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
                    startActivity(myIntent);
                    overridePendingTransition(R.anim.slide_in_right, R.anim.slide_out_left);
                    finish();
                    break;

                default:
                    btnMarkPicked.setBackgroundColor(ContextCompat.getColor(this, R.color.theme_color));
                    btnMarkPicked.setText("Mark it Picked");
                    currentStatus = "PICKED";
            }
        }
        else {
            btnMarkPicked.setBackgroundColor(ContextCompat.getColor(this, R.color.theme_color));
            currentStatus = "PICKED";
        }

    }

    public void showProgressDialog() {
        ProgressDialogFragment progressDialog = new ProgressDialogFragment();
        progressDialog.setCancelable(false);
        progressDialog.show(getSupportFragmentManager(), "progressDialog");
    }

    public void dismissProgressDialog() {
        ProgressDialogFragment progressDialog = (ProgressDialogFragment) getSupportFragmentManager().findFragmentByTag("progressDialog");
        if (progressDialog != null) {
            progressDialog.dismiss();
        }
    }
}