package com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice;

import com.utopiaindustries.selftrucking.models.Container;
import com.utopiaindustries.selftrucking.models.DriverResponse;
import com.utopiaindustries.selftrucking.models.LoginRequest;
import com.utopiaindustries.selftrucking.models.PickResponse;
import com.utopiaindustries.selftrucking.models.PickupRequest;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Path;
import retrofit2.http.Query;

public interface ApiService {
    @GET("rest/uic/inspection-report")
    Call<List<Container>> fetchAllReports(
            @Query("username") String username
    );

    @POST("rest/application/authenticate-user")
    Call<DriverResponse> isUserAuthenticated(
            @Body LoginRequest request
    );


    @POST("rest/application/save-truck-load")
    Call<PickResponse> pickTruckLoad(
            @Body PickupRequest request
    );
}


