package com.utopiaindustries.selftrucking.Activities.dashboardScreens.apiservice;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import java.util.concurrent.TimeUnit;

import okhttp3.OkHttpClient;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;

public class RetrofitClient {

    //"https://cosmos.utopiadeals.com/cosmos/";
    //http://192.168.90.228:8080/cosmos/
    private final static String BASE_URL = "https://cosmos.utopiadeals.com/cosmos/";

    private static Retrofit retrofit;

    public synchronized static Retrofit getClient() {

        Gson gson = new GsonBuilder()
                //.registerTypeAdapter(Boolean.class, new BooleanTypeAdapter())
                .create();


        if (retrofit == null) {
            try {

                OkHttpClient okHttpClient = new OkHttpClient.Builder()
                        .connectTimeout(40, TimeUnit.SECONDS)
                        .readTimeout(40, TimeUnit.SECONDS)
                        .writeTimeout(40, TimeUnit.SECONDS)
                        .build();

                retrofit = new Retrofit.Builder()
                        .baseUrl(BASE_URL)
                        .client(okHttpClient)
                        .addConverterFactory(GsonConverterFactory.create(gson))
                        .build();
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        return retrofit;
    }
}
