package com.utopiaindustries.selftrucking.helper;

import android.content.Context;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.text.TextUtils;

import androidx.preference.PreferenceManager;

import com.google.gson.Gson;
import com.utopiaindustries.selftrucking.models.DriverResponse;

public class Helper {

    public static final String project_file = "Self-Trucking";

    public static boolean isValidEmail(CharSequence target) {
        return !TextUtils.isEmpty(target) && android.util.Patterns.EMAIL_ADDRESS.matcher(target).matches();
    }

    static public void setPreferenceObject(Context c, Object modal, String key) {

        SharedPreferences appSharedPrefs = PreferenceManager.getDefaultSharedPreferences(c.getApplicationContext());
        SharedPreferences.Editor prefsEditor = appSharedPrefs.edit();

        Gson gson = new Gson();
        String jsonObject = gson.toJson(modal);
        prefsEditor.putString(key, jsonObject);
        prefsEditor.commit();

    }

    static public DriverResponse getPreferenceObjectJson(Context c, String key) {

        SharedPreferences appSharedPrefs = PreferenceManager.getDefaultSharedPreferences(c.getApplicationContext());

        String json = appSharedPrefs.getString(key, "");
        Gson gson = new Gson();
        DriverResponse selectedUser = gson.fromJson(json, DriverResponse.class);
        return selectedUser;
    }

    public static boolean isNetworkConnected(Context context) {
        ConnectivityManager connectivityManager = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo activeNetwork = connectivityManager.getActiveNetworkInfo();
        return activeNetwork != null && activeNetwork.isConnectedOrConnecting();
    }

    public static String escapeDoubleQuotes(String input) {
        if (input == null) return null;
        return input.replace("\"", "\\\""); // Add a backslash before the double quote
    }
}
